package dareka.launcher.logview;

import java.awt.Font;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import dareka.launcher.IconImage;

public class LogWindow {

	private static LogWindow instance = new LogWindow();

	private JFrame frame;
	private JTextArea textArea;

	private LogWindow() {
		frame = new JFrame("NicoCacheO");
		frame.setSize(320, 240);
		frame.setIconImage(IconImage.getImage());
		frame.setAlwaysOnTop(true);

		Font font = new Font(Font.MONOSPACED, Font.PLAIN, 16);

		textArea = new JTextArea();
		textArea.setFont(font);

		JScrollPane scrollPane = new JScrollPane(textArea);
		frame.add(scrollPane);
	}

	public static LogWindow getInstance() {
		return instance;
	}

	public void show() {
		frame.setVisible(true);
	}

	public synchronized void appendLog(String log) {
		textArea.append(log);
	}

	public void close() {
		instance = null;

		frame.dispose();
		frame = null;
	}

}
