package dareka.processor;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.net.Socket;

import dareka.common.Config;

public class StringResource extends Resource {
    private String message;

    public StringResource(String resource) {
        message = resource;
    }

    @Override
    public boolean transferTo(Socket receiver, HttpRequestHeader requestHeader,
            Config config) throws IOException {
        byte[] data = message.getBytes("UTF-8");

        HttpResponseHeader responseHeader = new HttpResponseHeader(
                "HTTP/1.1 200 OK\r\n\r\n");
        responseHeader.setMessageHeader(HttpHeader.CONNECTION, "keep-alive");
        responseHeader.setContentLength(data.length);

        fireOnResonseHeader(responseHeader);

        HttpUtil.sendHeader(receiver, responseHeader);

        HttpUtil.sendBody(receiver.getOutputStream(), new ByteArrayInputStream(
                data), data.length);

        return true;
    }

}
